function toCanvas(id ,progress){
    var canvas = document.getElementById(id),
    ctx = canvas.getContext("2d"),
    circleX = canvas.width / 2,  //中心x坐标
    circleY = canvas.height / 2,  //中心y坐标
    radius = 32, //圆环半径
    lineWidth = 5,  //圆形线条的宽度
    fontSize = 20; //字体大小
    function circle(cx, cy, r) {
        ctx.beginPath();
        ctx.lineWidth = lineWidth;
        ctx.strokeStyle = '#ffb7ba';
        ctx.arc(cx, cy, r, Math.PI*2/3, Math.PI * 1/3);
        ctx.stroke();
    }
    function sector(cx, cy, r, startAngle, endAngle, anti) {
        ctx.beginPath();
        ctx.lineWidth = lineWidth;
        var linGrad = ctx.createLinearGradient(
            circleX-radius-lineWidth, circleY, circleX+radius+lineWidth, circleY
        );
        linGrad.addColorStop(0.0, '#f42f38');
        linGrad.addColorStop(1.0, '#f42f38');
        ctx.strokeStyle = linGrad;
        ctx.lineCap = 'round';
        ctx.arc(
            cx, cy, r,
            (Math.PI*2/3),
            (Math.PI*2/3) + endAngle/100 * (Math.PI*5/3),
            false
        );
        ctx.stroke();
    }
    function loading() {
        ctx.clearRect(0, 0, circleX * 2, circleY * 2);
        circle(circleX, circleY, radius);
        sector(circleX, circleY, radius, Math.PI*2/3, progress)
    }
    loading();
}
toCanvas('canvas',40);
// toCanvas第一个参数是canvas的id 
// toCanvas第一个参数是红色占粉色的百分比 总为100 