var Utility=function(){

    var _root_path="http://192.168.10.122:83/";//域名（路径）
    // 判断值是否是 string 类型；返回 true 表示是 string 类型，false 表示不是。
    var isString = function(value){
        return (value && typeof value === 'string');
    };


    // 判断字符串变量是否有值。返回 true 表示有值，false 表示没有值或不是 string 类型。
    var stringHasValue = function(value){
        return isString(value) && value != '';
    };

   return {
       /*****获取手机api相册或者拍照********
        * options  参数对象
        * callback  回调函数
        ************/
       apiGetPicture: function (options, callback) {
           options = $.extend(true, {
               sourceType: "camera",//图片源类型，从相册、图片库或相机获取图片  library（图片库）、camera（相机）、album（相册）
               encodingType: "jpg",//返回图片类型  jpg或png  默认值png
               mediaValue: "pic",//媒体类型，图片或视频  pic（图片）、video（视频）、all（图片和视频，Android不支持）
               destinationType: "url",//返回数据类型，指定返回图片地址或图片经过base64编码后的字符串  url(选取的图片地址)、base64（base64编码后内容）
               quality: 50,//图片压缩质量，默认值50，值越小压缩质量越差
               saveToPhotoAlbum : true,//（可选项）拍照或录制视频后是否保存到相册  默认值false
               allowEdit:false,//是否可以选择图片后进行编辑，支持iOS及部分安卓手机  默认值false
               videoQuality:"medium"//视频质量，取值范围(low、medium、high)，只支持iOS  默认值medium
               //targetWidth      //压缩后的图片宽度，图片会按比例适配此宽度  默认值原图宽度
               //targetHeight     //压缩后的图片高度，图片会按比例适配此高度  默认值原图高度
           }, options);
           api.getPicture(options, function (ret, err) {
               if(ret && ret.data){
               callback(ret, err);
               }else{alert("上传图片出现异常，请稍后重试！");this.hideProgress();}
           });
       },
       /**************************
        * 监听事件，支持系统事件和自定义事件
        * @param {Object} 要设置的参数
        * @param {Object} 回调函数
        ***********************************/
       addEventListener: function (options, callback) {
           options = $.extend(true, {
               name: 'scrolltobottom',//自定义事件或系统事件名称
               extra: {   //（可选项）附加字段。一些特定事件可能需要提供额外的参数  json对象
                   threshold: 0 //设置距离底部多少距离时触发，默认值为0，数字类型
               }
           }, options);
           api.addEventListener(options, function (ret, err) {
               callback(ret, err);
           });
       },
       //移除监听事件
       removeEventListener: function (options) {
           options = $.extend(true, {
               name: 'scrolltobottom'
           }, options);
           api.removeEventListener(options);
       },
       /*****图片压缩*****
        * imageFilter 对象（api.require("imageFilter"))
        * options 参数对象
        * callback 回调函数，返回图片路径
        **************/
       apiImageFilterCompress:function(imageFilter,options,callback){
           // 压缩文件的保存目录           
			var savePath = api.cacheDir + "/" + new Date().format("yyyy-MM-dd") + "/";
			// 压缩文件生成的随机文件名称
			var saveName = this.newGuid() + "." + this.extFileName(options.img);
		
            options=$.extend(true,{
			    img: '',//字符串类型，图片地址
			    quality:0.5, //数字类型，（可选项）压缩程度，取值范围：0-1  默认值0.5
			    scale:0.5,//数字类型，（可选项）压缩后的图片缩放比例，取值范围大于0  默认值1          它与size参数是互斥的
			    save:{
                    album : false,
                    imgPath : savePath,
                    imgName : saveName
                }
			},options);			
			imageFilter.compress(options,function(ret,err){if(ret.status){callback(savePath + saveName,err);}});
       },
       actionSheet:function(options,callback){
          options= $.extend(true,{
              title : '选择图片来源',
              buttons : ['优雅自拍', '浏览相册']
          },options);
           api.actionSheet(options,function(ret,err){callback(ret,err);});
       },
       //显示进度提示框
       showProgress:function(options){
         options= $.extend(true,{
             style : 'default',
             animationType : 'fade',
             title : '操作中',
             text : '请稍等...',
             modal : true
         },options);
           api.showProgress(options);
       },
       //自动消失页面提示框（页面可以统一调用此函数）
       toast: function (options) {
           options = $.extend(true, {
               msg: '操作成功',
               duration: 2000,
               location: 'bottom'
           }, options);
           api.toast(options);
       },
       /***************
        * 打开window
        若 window 已存在，则会把该 window 显示到最前面，如果 url 和之前的 url 有变化，或者 reload 为 true 时，页面会刷新，但是该 window 里面已经打开的 frame 等不会移除
        若当前正在进行 openWin、closeWin 等带动画过渡的 window 操作，调用此方法会失效
        * @param options
        */
       openWin:function(options){
           options= $.extend(true,{
               name:"root", //window 名字，不能为空字符串
               url:"",//页面地址，可以为本地文件路径，支持相对路径和绝对路径，以及 widget://、fs://等协议路径，也可以为远程地址
               useWKWebView:false,//是否使用WKWebView来加载页面，只支持iOS8.0及以上系统。WKWebView是iOS8新出的WebKit库中的控件，相比于以前的UIWebView，在性能和功能等方面都有所提升。注意使用WKWebView后，localStorage可能不能和其它未使用WKWebView加载的页面通用
               pageParam:{

               },//页面参数，新页面中可以通过 api.pageParam 获取
               /*
                /默认值：若在 config.xml 里面配置了 windowBackground，则默认值为配置的值，否则透明
                描述：背景色，支持图片和颜色，格式为 #fff、#ffffff、rgba(r,g,b,a)等，图片路径支持 fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                */
               // bgColor:"",
               scrollToTop:false,//当点击状态栏，页面是否滚动到顶部。若当前屏幕上不止一个页面的 scrollToTop 属性为 true，则所有的都不会起作用。只 iOS 有效
               vScrollBarEnabled:true,//是否显示垂直滚动条
               hScrollBarEnabled:true,//是否显示水平滚动条
               scaleEnabled:false,//页面是否可以缩放
               slidBackEnabled:true,//是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
               slidBackType:"full",//当支持滑动返回时，设置手指在页面右滑的有效作用区域。取值范围（full:整个页面范围都可以右滑返回，edge:在页面左边缘右滑才可以返回），该字段只iOS有效
               reload:false,//页面已经打开时，是否重新加载页面，重新加载页面后 apiready 方法将会被执行
               allowEdit:false,//是否允许长按页面时弹出选择菜单
               softInputMode:"auto",//当键盘弹出时，输入框被盖住时，当前页面的调整方式，详见键盘弹出页面调整方式常量；只iOS有效，Android请在 config.xml 里面配置并云编译使用
               //customRefreshHeader:"",//设置使用自定义下拉刷新模块的名称，设置后可以使用 api.setCustomRefreshHeaderInfo 方法来使用自定义下拉刷新组件
               /*animation:{
                /!****** type 类型参数值
                * none            //无动画效果
                push            //新视图将旧视图推开
                movein            //新视图移到旧视图上面
                fade            //交叉淡化过渡（不支持过渡方向）
                flip            //翻转效果
                reveal            //将旧视图移开,显示下面的新视图
                ripple            //滴水效果（不支持过渡方向）
                curl            //向上翻一页
                un_curl            //向下翻一页
                suck            //收缩效果（不支持过渡方向）
                cube            //立方体翻滚效果
                ****************************!/
                type:"none",                //动画类型（详见动画类型常量）
                /!******subType 动画子类型参数值
                *   from_right        //从右边开始动画
                from_left        //从左边开始动画
                from_top        //从顶部开始动画
                from_bottom        //从底部开始动画
                *************** *!/
                subType:"from_right",       //动画子类型（详见动画子类型常量）
                duration:300   ////动画过渡时间，默认300毫秒
                }*////（可选项）动画参数，不传时使用默认动画，type：动画类型，subType：动画子类型。
           },options);
           api.openWin(options);
       },
       /***************
        * 关闭 window
        若当前正在进行 openWin、closeWin 等带动画过渡的 window 操作，调用此方法会失效
        * @param options
        */
       closeWin:function(options){
           options= $.extend(true,{
               //name: 'root',//（可选项）window 名字，不传时关闭当前 window，为 root 时无效
               /*animation:{
                /!****** type 类型参数值
                * none            //无动画效果
                push            //新视图将旧视图推开
                movein            //新视图移到旧视图上面
                fade            //交叉淡化过渡（不支持过渡方向）
                flip            //翻转效果
                reveal            //将旧视图移开,显示下面的新视图
                ripple            //滴水效果（不支持过渡方向）
                curl            //向上翻一页
                un_curl            //向下翻一页
                suck            //收缩效果（不支持过渡方向）
                cube            //立方体翻滚效果
                ****************************!/
                type:"none",                //动画类型（详见动画类型常量）
                /!******subType 动画子类型参数值
                *   from_right        //从右边开始动画
                from_left        //从左边开始动画
                from_top        //从顶部开始动画
                from_bottom        //从底部开始动画
                *************** *!/
                subType:"from_right",       //动画子类型（详见动画子类型常量）
                duration:300   ////动画过渡时间，默认300毫秒
                }*////（可选项）动画参数，不传时使用默认动画，type：动画类型，subType：动画子类型。
           },options);
           api.closeWin(options);
       },
       /***************
        * 关闭到指定 window，最上面显示的 window 到指定 name 的 window 间的所有 window 都会被关闭
        若当前正在进行 openWin、closeWin 等带动画过渡的 window 操作，调用此方法会失效
        * @param options
        */
       closeToWin:function(options){
           options= $.extend(true,{
               name: 'root',//window 名字
               /*animation:{
                /!****** type 类型参数值
                * none            //无动画效果
                push            //新视图将旧视图推开
                movein            //新视图移到旧视图上面
                fade            //交叉淡化过渡（不支持过渡方向）
                flip            //翻转效果
                reveal            //将旧视图移开,显示下面的新视图
                ripple            //滴水效果（不支持过渡方向）
                curl            //向上翻一页
                un_curl            //向下翻一页
                suck            //收缩效果（不支持过渡方向）
                cube            //立方体翻滚效果
                ****************************!/
                type:"none",                //动画类型（详见动画类型常量）
                /!******subType 动画子类型参数值
                *   from_right        //从右边开始动画
                from_left        //从左边开始动画
                from_top        //从顶部开始动画
                from_bottom        //从底部开始动画
                *************** *!/
                subType:"from_right",       //动画子类型（详见动画子类型常量）
                duration:300   ////动画过渡时间，默认300毫秒
                }*////（可选项）动画参数，不传时使用默认动画，type：动画类型，subType：动画子类型。
           },options);
           api.closeToWin(options);
       },
       //隐藏进度提示框
       hideProgress:function(){
           api.hideProgress();
       },
       // 获取文件拓展名
       extFileName:function(fileName){
          return fileName.substring(fileName.lastIndexOf('.') + 1);
       },
       // 生成guid,主要用于生成随机文件名
       newGuid:function(){
         function Guid() {
				return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
			}
        return (Guid() + Guid() + "-" + Guid() + "-" + Guid() + "-" + Guid() + "-" + Guid() + Guid() + Guid());
       },
       // 获取服务端API路径
		getAPIPath : function(){
			if(arguments.length != 2 && arguments.length != 3) throw 'Argument error.(incorrect number of arguments)';
			var result = _root_path + 'api';
			for(var i in arguments)
			{
				result += '/' + arguments[i];
			}
			return result;
		},
       // 获取系统根路径，根路径必须以“/”结尾。
       getRootPath : function(){
           return _root_path;
       },
       // 设置系统根路径。
       setRootPath : function(path){
           if(!stringHasValue(path)) throw 'Set the root path error.(invalid root path)';

           path = path.replace(/\\/g, '/');
           if(path.charAt(path.length - 1) != '/'){
               path += '/';
           }
           _root_path = path;
       },
       //设置缓存数据（APICloud自置函数）
       setStorage:function(key,value){  $api.setStorage(key,value);},
       //获取缓存数据（APICloud自置函数）
       getStorage:function(key){return $api.getStorage(key);},
       /********************
        * 说明：因为APICloud的api.ajax post提交类似于form表单提交，data里面的参数files 类似于我们平时页面上的file文本
        * 会自动添加enctype=“multipart/form-data” 提交上传的文件，而jquery 的ajax需要手动在form表单添加这个属性
        * 为了方便，则文件上传时采用api.ajax方式提交
        *******************/
       fileUploadImg:function(options,callback){
          options= $.extend(true,{
               url : "",//请求地址
               //tag    //默认值无  （可选项）请求标识，可以传递此字段给 cancelAjax 方法来取消请求
               method : 'post',//异步请求方法类型  默认get   支持类型get\post\put\delete\head
               timeout : 30,//超时时间，单位秒   默认30
               dataType : 'json',//返回数据类型    默认json  支持类型json、text
               charset:"utf-8",//当响应头里面没有返回字符集编码时，使用此编码来解析数据  默认值utf-8
               //headers    //请求头  json对象
               report:false,//是否实时返回上传文件进度  默认false               
               returnAll : false,//是否需要返回所有 response 信息，为 true 时，返回的头信息获取方法(ret.headers)，消息体信息获取方法(ret.body)，状态码获取方法(ret.statusCode)
               //certificate     //https 安全证书设置。
               data : {          //POST 数据，method 为 get 时不传。以下字段除了 values 和 files 可以同时使用，其它参数都不能同时使用
                   files : {     //values和files 都是json对象
                       "file" : ""
                   }
               }
           },options);
           api.ajax(options,function(ret,err){
              if(ret!=null){
                  callback(ret,err);
              }else{
                  this.hideProgress();
                  alert("系统繁忙，请稍后重试！");
              }
           });
       },
       /***************
        *  此函数是调用服务端API统一封装的
        *  说明：api.ajax get方式提交 要求data不传递参数，而需要自己去拼接字符串，不便于书写 。为了以后维护起来方便，则改用jquery的ajax方式
        *  对jquery的ajax进行了二次封装，要求返回结果是一个json对象，并且格式是Data\Code(0(失败），1（成功）,2（未登录）,3（已在其他设备登录）)\Message
        ***************/
       callAPI : function(options){
           options = $.extend(true, {
               "type":"GET",
               "dataType":"json"
           }, options);

           var successHandler = options.success;
           var errorHandler = options.error;
           var failHandler = options.fail;

           options.success = function(response, textState, xhr){
               if(stringHasValue(response)){response=JSON.parse(response);}
               if(response){
                   if(!response.Code) {
                       if(failHandler && typeof(failHandler) === "function"){
                           if(failHandler(response, textState, xhr) == false) return false;
                       }
                      // $.scojs_message("<strong>系统错误：</strong>" + response.Message, $.scojs_message.TYPE_ERROR);
                       Utility.hideProgress();
                   }
                   else if(response.Code == 1){
                       if(successHandler && typeof(successHandler) === "function"){
                           successHandler(response, textState, xhr);
                       }
                   }
                   else if(response.Code == 101){
                       if(successHandler && typeof(successHandler) === "function"){
                           successHandler(response, textState, xhr);
                       }
                   }
                   else if(response.Code == 2) {
                      // Utility.loginTimeoutHandler(response.Message);
                       Utility.hideProgress();
                   }
                   else if(response.Code != 1){
                     //  $.scojs_message("<strong>系统错误：</strong>返回意外结果！Code：" + response.Code + "，Message：" + response.Message, $.scojs_message.TYPE_ERROR);
                       Utility.hideProgress();
                   }

               }else {
                   Utility.hideProgress();
                  // $.scojs_message("<strong>系统异常：</strong>返回意外结果!", $.scojs_message.TYPE_ERROR);
               }
           };
           options.error = function(xhr, textState, errorThrown){
               if(errorHandler && typeof(errorHandler) === "function"){
                   errorHandler(xhr, textState, errorThrown);
                   Utility.hideProgress();
               }
               else
               {
                   if(xhr.status == 404){
                      // $.scojs_message("<strong>找不到服务：</strong>请求的服务器资源不存在！", $.scojs_message.TYPE_ERROR);
                       Utility.hideProgress();
                   }
                   else if(xhr.status == 503) {
                      // $.scojs_message("<strong>服务器繁忙：</strong>目前请求数落太多，请先停下来喝杯茶歇一歇！", $.scojs_message.TYPE_OK);
                       Utility.hideProgress();
                   }
                   else{
                       Utility.hideProgress();
                     //  $.scojs_message("<strong>系统异常：</strong>请稍后重试！状态码：" + xhr.status + "，错误代号：" + errorThrown + "！", $.scojs_message.TYPE_ERROR);
                   }
               }
           };

           $.ajax(options);
       },
       /*********************
        * 分享功能
        * options :分享相关参数设置
        * docSayId:具体的内容标识
        *********************/
       shareWebPage:function(options,docSayId){
           var wx = api.require('wx');
           options= $.extend(true,{
               apiKey : '',
               scene : "session",
               title : "",
               description : "'",
               thumb : 'widget://image/2.png',
               contentUrl : Utility.getStorage("url")+'/Share/DocSay/DocSayConditionAnalytical.html?docsayid=' + docSayId
           },options);
           wx.shareWebpage(options, function(ret, err) {
               if (ret.status) {
					//alert('分享成功');
                   Utility.toast();
               } else {
                   if (err.code == 3) {
                       alert('未安装微信客户端');
                       return false;
                   }
               }
           });
       },
       /************
        * 发送推送消息
        * @param options
        */
       sendTextMessage:function(options){
           //代表医生,(因为用户app获取的医生编号都来源于chongwu_yisheng表的id，而医生app则需要登录账号的id，所以此次在此进行转换）
           if(options.targetId.substr(0,1)=="D"){
               var docId=options.targetId.substr(1,options.targetId.length);
               var key="yishengloginId"+docId;
               var yishengloginId=0;
               var cacheYiShengId=Utility.getStorage(key);
               if(cacheYiShengId!=undefined && cacheYiShengId!="" && cacheYiShengId!=null){yishengloginId=cacheYiShengId;}
               var param = {
                   ClassName: "AppDocSayBLL",
                   MethodName: "GetDocLoginIdByChongWuYiShengId",
                   Parameters: {
                       chongwuyishengId:docId
                   }
               };
               Utility.callAPI({
                   url:Utility.getStorage('url')+"/api/PhoneUser",
                   //url:"http://192.168.10.119:83/api/PhoneUser",
                   type:"post",
                   async:false,
                   data : '=' + JSON.stringify(param),
                   success:function(data){
                       if(parseInt(data.RMessage)>0){
                           Utility.setStorage(key,data.RMessage);
                           yishengloginId=data.RMessage;
                       }
                   }
               });
               options.targetId="D"+yishengloginId;
           }
           options= $.extend(true,{
               conversationType : 'PRIVATE',
               targetId : "", //用户是U加上用户的appphontloginid 医生是Y加上医生的phonrloginid
               text : '#XX#:123',
               extra : ''
           },options);
           //alert(JSON.stringify(options));
           var rong = api.require('rongCloud2');
           rong.sendTextMessage(options, function(ret, err) {});
       },
       /***********
        * 打开图片浏览
        * @param options
        */
       openImages:function(options) {
           // 引入图片浏览模块
           var imageBrowser= api.require('imageBrowser');
           options= $.extend(true,{
               imageUrls: "",
               showList: false,
               activeIndex: 0
           },options);
           imageBrowser.openImages(options);
       }
   }
}();



/* * * * * * * * * * * * * * * * * * * * * * * *
 * 扩展js属性
 * * * * * * * * * * * * * * * * * * * * * * * */
String.prototype.bytesLength = function(){
	var result = 0;
	for(var i= 0, len = this.length; i<len; i++){
		if(this.charCodeAt(i) & 0xff00 != 0) {
			result += 2;
		}
		else{
			result++;
		}
	}
	return result;
};

Date.prototype.addMilliseconds = function(value){
	if(!Common.isNumber(value)) throw('the paramenter "value" must be a float type.');

	return new Date(this.valueOf() + value);
};
Date.prototype.addSeconds = function(value){
	if(!Common.isNumber(value)) throw('the paramenter "value" must be a float type.');

	return new Date(this.valueOf() + value * 1000);
};
Date.prototype.addMinutes = function(value){
	if(!Common.isNumber(value)) throw('the paramenter "value" must be a float type.');

	return new Date(this.valueOf() + value * 60000); //60000 = 60 * 1000
};
Date.prototype.addHours = function(value){
	if(!Common.isNumber(value)) throw('the paramenter "value" must be a float type.');

	return new Date(this.valueOf() + value * 3600000); //3600000 = 60 * 60 * 1000
};
Date.prototype.addDays = function(value){
	if(!Common.isNumber(value)) throw('the paramenter "value" must be a float type.');

	return new Date(this.valueOf() + value * 86400000); //86400000 = 24 * 60 * 60 * 1000
};
Date.prototype.addMonths = function(value){
	if(!Common.isNumber(value)) throw('the paramenter "value" must be a integer type.');

	var result = new Date(this);
	result.setMonth(result.getMonth() + Math.floor(value));

	if(result.getDate() < this.getDate()){
		result.setDate(0);
	}
	return result;
};
Date.prototype.addYears = function(value){
	if(!Common.isNumber(value)) throw('the paramenter "value" must be a integer type.');

	var result = new Date(this);
	result.setFullYear(result.getFullYear() + Math.floor(value));
	if(result.getDate() < this.getDate()){
		result.setDate(0);
	}
	return result;
};
Date.prototype.format = function (formatString) {
	var o = {
		"M+": this.getMonth() + 1, //鏈堜唤
		"d+": this.getDate(), //鏃�
		"h+": this.getHours(), //灏忔椂
		"m+": this.getMinutes(), //鍒�
		"s+": this.getSeconds(), //绉�
		"q+": Math.floor((this.getMonth() + 3) / 3), //瀛ｅ害
		"f": this.getMilliseconds() //姣
	};
	if (/(y+)/.test(formatString)) formatString = formatString.replace(RegExp.$1, (this.getFullYear().toString()).substr(4 - RegExp.$1.length));
	for (var k in o)
	{
		if (new RegExp("(" + k + ")").test(formatString)) formatString = formatString.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
	}
	return formatString;
};